/***************************************************************************
   Copyright (C) 2007
   by Marco Gulino <marco@kmobiletools.org>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the
   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
 ***************************************************************************/
#ifndef DEVICEMENU_H
#define DEVICEMENU_H

#include <kpopupmenu.h>
#include <kurl.h>

/**
@author Marco Gulino
*/
class kmobiletoolsEngine;
class deviceMenu : public KPopupMenu
{
Q_OBJECT
public:
    deviceMenu(bool loaded=false, kmobiletoolsEngine *engine=NULL, QWidget *parent = 0, const char *name = 0);

    ~deviceMenu();
private:
    kmobiletoolsEngine *p_engine;

public slots:
    void slotItemClicked(int id);

signals:
    void switchDevice(const QString &);
    void loadDevice(const QString &);
    void unloadDevice(const QString &);
    void configure(const QString &);
    void sendURL(const KURL&);
};

#endif
